{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs {$ENDIF}, cases;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$ENDIF}

type
  TBMPPalette=array[0..255]of record
                                 R,G,B,F: Byte;
                               end;

  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    OpenDirDialog1: TKOLOpenDirDialog;
    Panel1: TKOLPanel;
    ListBox1: TKOLListBox;
    Panel2: TKOLPanel;
    Label2: TKOLLabel;
    EditBox2: TKOLEditBox;
    Button2: TKOLButton;
    MainMenu1: TKOLMainMenu;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    KOLApplet1: TKOLApplet;
    Panel3: TKOLPanel;
    GroupBox2: TKOLGroupBox;
    ListBox2: TKOLListBox;
    GroupBox1: TKOLGroupBox;
    Button1: TKOLButton;
    Button3: TKOLButton;
    OpenDirDialog2: TKOLOpenDirDialog;
    CheckBox1: TKOLCheckBox;
    ScrollBox1: TKOLScrollBox;
    PaintBox1: TKOLPaintBox;
    procedure ProduceFileList(Mask: string);
    procedure Button1Click(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    procedure ListBox1Click(Sender: PObj);
    procedure ListBox2Click(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure KOLForm1N3Menu(Sender: PMenu; Item: Integer);
    procedure KOLForm1N2Menu(Sender: PMenu; Item: Integer);
    procedure PaintBox1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  procedure Expand(N: Byte; var BL,BR: Byte);
  procedure GetSprite(SIndex: LongInt; var SOut: PStream);

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  TotalEntries: LongInt;
  CurrentDEFName: string;
  TempBmp: PBitmap;
  AllowRepaint: Boolean;
  FDef: PStream;                  //  DEF (File)
  FBmp,                           // BMP (Memory)
  FTemp: PStream;                 //  (Memory)
  DEFType: LongInt;               //  DEF
  CurDir: string;                 // 
  BMPPalette: TBMPPalette;        //
  TotalBlocks: LongInt;           //    
  TempLongInt: LongInt;           // 
  TempString: String;             // 
  FullWidth: LongInt;             //   DEF
  FullHeight: LongInt;            //   DEF
  FBuffer: array[1..800]of char;  // 
  RWEntries: array of Word;
  RLEntries: array of LongInt;
  SEntries: array of record       // 
                       Name: string;
                       Offset: LongInt;
                     end;
  id: array[1..2]of char;         // BMP
  BMPHeader: RECORD               // BMP
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses About, Wait;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

procedure Expand(N: Byte; var BL,BR: Byte);
begin
  BL:=(N and $E0) shr 5;
  BR:=N and $1F;
end;

procedure TForm1.ProduceFileList(Mask: string);
var
  Attrs: Byte;
begin
  Attrs:=$FF-DDL_Directory;
  ListBox1.Clear;
  ListBox1.AddDirList(Mask,Attrs);
  EditBox2.Text:=GetShortPath(Mask);
end;

procedure TForm1.Button1Click(Sender: PObj);
begin
  if OpenDirDialog1.Execute then
  begin
    ProduceFileList(OpenDirDialog1.Path+'\*.def');
    OpenDirDialog1.InitialPath:=OpenDirDialog1.Path;
  end;
end;

procedure TForm1.Button2Click(Sender: PObj);
var
  ComplexBmp,TBmp: PBitmap;
  i,ComplexWidth,ComplexHeight,Si,Add: LongInt;
begin
  if ListBox2.SelLength=0 then Exit;
//  - 
    Form3.Label1.Caption:=' ...';
    Form3.Form.Visible:=True;
    Form3.Form.Update;
//  
    ComplexBmp:=NewBitmap(1,1);
//        
    if CheckBox1.Checked then Add:=1 else Add:=0;
    i:=-1;
    repeat
      Inc(i);
    until ListBox2.ItemSelected[i];
    FBmp:=NewMemoryStream;
    GetSprite(i,FBmp);
    FBmp.Seek(0,spBegin);
    ComplexBmp.LoadFromStream(FBmp);
    FBmp.Free;
    Si:=i;
    if ListBox2.SelLength>1 then
    begin
      for i:=Si+1 to ListBox2.Count-1 do
      if ListBox2.ItemSelected[i] then
      begin
        FBmp:=NewMemoryStream;
        GetSprite(i,FBmp);
        FBmp.Seek(0,spBegin);
        TBmp:=NewBitmap(1,1);
        TBmp.LoadFromStream(FBmp);
        ComplexBmp.Width:=ComplexBmp.Width+TBmp.Width+Add;
        TBmp.Draw(ComplexBmp.Canvas.Handle,ComplexBmp.Width-TBmp.Width,0);
        TBmp.Free;
        FBmp.Free;
      end;
    end;
  AllowRepaint:=True;
  FBmp:=NewMemoryStream;
  ComplexBmp.SaveToStream(FBmp);
  FBmp.Seek(0,spBegin);
  TempBmp.LoadFromStream(FBmp);
  FBmp.Free;
  PaintBox1.Width:=TempBmp.Width;
  PaintBox1.Height:=TempBmp.Height;
  TempBmp.Draw(PaintBox1.Canvas.Handle,0,0);
  ComplexBmp.Free;
  Form3.Form.Visible:=False;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  TempBmp:=NewBitmap(1,1);
  //  BMP
  id[1]:='B';
  id[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  GetDir(0,CurDir);
  OpenDirDialog1.InitialPath:=CurDir;
  OpenDirDialog2.InitialPath:=CurDir;
//  OpenSaveDialog1.InitialDir:=CurDir;
  AllowRepaint:=False;
end;

procedure TForm1.ListBox1Click(Sender: PObj);
var
  i,j: LongInt;
  TotalInBlock: LongInt;
  Buffer: array[0..12]of char;
begin
  if ListBox1.CurIndex<0 then Exit;
  CurrentDEFName:=OpenDirDialog1.Path+'\'+ListBox1.Items[ListBox1.CurIndex];
  FDef:=NewReadFileStream(CurrentDEFName);
  //  
  FDef.Read(DEFType,4);
  //    DEF
  FDef.Read(FullWidth,4);
  FDef.Read(FullHeight,4);
  //  
  FDef.Seek($0C,spBegin);
  FDef.Read(TotalBlocks,4);
  // 
  FDef.Seek($10,spBegin);
  for i:=0 to 255 do
  begin
    FDef.Read(BMPPalette[i].B,1);
    FDef.Read(BMPPalette[i].G,1);
    FDef.Read(BMPPalette[i].R,1);
    BMPPalette[i].F:=$00;
  end;
  //  
  FDef.Seek($310,spBegin);
  TotalEntries:=0;
  for i:=1 to TotalBlocks do
  begin
    FDef.Seek($04,spCurrent);
    FDef.Read(TotalInBlock,4);
    SetLength(SEntries,TotalEntries+TotalInBlock);
    FDef.Seek($08,spCurrent);
    for j:=0 to TotalInBlock-1 do
    begin
      FDef.Read(Buffer,13);
      if Pos(#$00,Buffer)=0 then SEntries[TotalEntries+j].Name:=Copy(Buffer,1,13) else SEntries[TotalEntries+j].Name:=Copy(Buffer,1,Pos(#$00,Buffer)-1);
    end;
    for j:=0 to TotalInBlock-1 do FDef.Read(SEntries[TotalEntries+j].Offset,4);
    TotalEntries:=TotalEntries+TotalInBlock;
  end;
  //      
  for j:=0 to TotalEntries-1 do
  for i:=0 to TotalEntries-2 do
  if SEntries[i].Offset>SEntries[i+1].Offset then
  begin
    TempLongInt:=SEntries[i].Offset;
    SEntries[i].Offset:=SEntries[i+1].Offset;
    SEntries[i+1].Offset:=TempLongInt;
    TempString:=SEntries[i].Name;
    SEntries[i].Name:=SEntries[i+1].Name;
    SEntries[i+1].Name:=TempString;
  end;
  //  
  ListBox2.Clear;
  for i:=1 to TotalEntries do ListBox2.Add(SEntries[i-1].Name);
  FDef.Free;
  ListBox2.CurIndex:=0;
  ListBox2.OnSelChange(ListBox2);
end;

procedure GetSprite(SIndex: LongInt; var SOut: PStream);
var
  BaseOffset: LongInt;
  SpriteWidth,
  SpriteHeight: LongInt; // 
  LeftMargin,
  TopMargin,
  RightMargin,
  BottomMargin: LongInt; //    
  i,Add: LongInt;
  TotalRowLength: LongInt;        //  
  SegmentType: Byte;
  SegmentLength: Byte;
  NextSpriteOffset: LongInt;
  RowAdd: LongInt;
  TempDef: PStream;     // (Memory)
  BL,BR: Byte;
begin
  FDef:=NewReadFileStream(CurrentDEFName);
  TempDef:=NewMemoryStream;
  //     
  NextSpriteOffset:=NextSpriteOffset;
  Stream2Stream(TempDef,FDef,FDef.Size);
  FDef.Free;
  //   
  BaseOffset:=SEntries[SIndex].Offset;
  //   
  TempDef.Seek(BaseOffset,spBegin);
  //   
  TempDef.Read(NextSpriteOffset,4);
  TempDef.Read(DEFType,4);
  //     
  TempDef.Read(FullWidth,4);
  TempDef.Read(FullHeight,4);
  //   
  TempDef.Read(SpriteWidth,4);
  TempDef.Read(SpriteHeight,4);
  TempDef.Read(LeftMargin,4);
  TempDef.Read(TopMargin,4);
  //  
  RightMargin:=FullWidth-SpriteWidth-LeftMargin;
  BottomMargin:=FullHeight-SpriteHeight-TopMargin;
  //  BMP
//  FBmp:=NewMemoryStream;
  SOut.Seek(0,spBegin);
  //  BMP
  BMPHeader.x:=FullWidth;
  BMPHeader.y:=FullHeight;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  //  
  Add:=Round(Int((4*(1-(Frac(FullWidth/4))))));
  if Add=4 then Add:=0;
  //  BMP   
  SOut.Write(id,2);
  SOut.Write(BMPHeader,SizeOf(BMPHeader));
  SOut.Write(BMPPalette,1024);
{**********     **********}
  //  
  FTemp:=NewMemoryStream;
  //    
  BaseOffset:=TempDef.Position;
  FillChar(FBuffer,800,#$00);
  {*****  - 00 *****}
  if (DEFType=$00)then
  begin
    //  
    if TopMargin>0 then
    for i:=1 to TopMargin do FTemp.Write(FBuffer,FullWidth+Add);
    //  
    for i:=1 to SpriteHeight do
    begin
      //  
      if LeftMargin>0 then FTemp.Write(FBuffer,LeftMargin);
      Stream2Stream(FTemp,TempDef,SpriteWidth);
      //  
      if RightMargin>0 then FTemp.Write(FBuffer,RightMargin);
      if Add>0 then FTemp.Write(FBuffer,Add);
    end;
    //  
    if BottomMargin>0 then
    for i:=1 to BottomMargin do FTemp.Write(FBuffer,FullWidth+Add);
  end;
  {*****  - 01 *****}
  if (DEFType=$01)then
  begin
    //  
    if TopMargin>0 then
    for i:=1 to TopMargin do FTemp.Write(FBuffer,FullWidth+Add);
    //  
    SetLength(RLEntries,SpriteHeight);
    for i:=1 to SpriteHeight do TempDef.Read(RLEntries[i-1],4);
    //  
    for i:=1 to SpriteHeight do
    begin
      TempDef.Seek(BaseOffset+RLEntries[i-1],spBegin);
      //  
      if LeftMargin>0 then FTemp.Write(FBuffer,LeftMargin);
      TotalRowLength:=0;
      repeat
        TempDef.Read(SegmentType,1);
        TempDef.Read(SegmentLength,1);
        case SegmentType of
        $FF: begin
               Stream2Stream(FTemp,TempDef,SegmentLength+1);
               TotalRowLength:=TotalRowLength+SegmentLength+1;
             end;
        else begin
               FTemp.Write(FBuffer,SegmentLength+1);
               TotalRowLength:=TotalRowLength+SegmentLength+1;
             end;
        end;
      until TotalRowLength>=SpriteWidth;
      RowAdd:=SpriteWidth-TotalRowLength;
      //  
      if RightMargin>0 then FTemp.Write(FBuffer,RightMargin);
      if Add>0 then FTemp.Write(FBuffer,Add+RowAdd);
      // 
    end;
    //  
    if BottomMargin>0 then
    for i:=1 to BottomMargin do FTemp.Write(FBuffer,FullWidth+Add);
  end;
  {*****  - 03 *****}
  if (DEFType=$03)then
  begin
    //  
    if TopMargin>0 then
    for i:=1 to TopMargin do FTemp.Write(FBuffer,FullWidth+Add);
    //  
    SetLength(RWEntries,SpriteHeight);
    for i:=1 to SpriteHeight do
    begin
      TempDef.Seek(BaseOffset+(i-1)*2*(SpriteWidth div 32),spBegin);
      TempDef.Read(RWEntries[i-1],2);
    end;
    //  
    for i:=1 to SpriteHeight do
    begin
      TempDef.Seek(BaseOffset+RWEntries[i-1],spBegin);
      //  
      if LeftMargin>0 then FTemp.Write(FBuffer,LeftMargin);
      TotalRowLength:=0;
      repeat
        TempDef.Read(SegmentType,1);
        Expand(SegmentType,BL,BR);
        case BL of
          $0: begin     //
                FillChar(FBuffer,100,#$00);
                FTemp.Write(FBuffer,BR+1);
                TotalRowLength:=TotalRowLength+BR+1;
              end;
          $1: begin     //
                FillChar(FBuffer,100,#$00);
                FTemp.Write(FBuffer,BR+1);
                TotalRowLength:=TotalRowLength+BR+1;
              end;
          $4: begin     //
                FillChar(FBuffer,100,#$00);
                FTemp.Write(FBuffer,BR+1);
                TotalRowLength:=TotalRowLength+BR+1;
              end;
          $5: begin     //    (?)
                FillChar(FBuffer,100,#$00);
                FTemp.Write(FBuffer,BR+1);
                TotalRowLength:=TotalRowLength+BR+1;
              end;
          $7: begin    //
                Stream2Stream(FTemp,TempDef,BR+1);
                TotalRowLength:=TotalRowLength+BR+1;
              end;
        end;
      until TotalRowLength>=SpriteWidth;
      //  
      if RightMargin>0 then FTemp.Write(FBuffer,RightMargin);
      if Add>0 then FTemp.Write(FBuffer,Add);
      // 
    end;
    //  
    if BottomMargin>0 then
    for i:=1 to BottomMargin do FTemp.Write(FBuffer,FullWidth+Add);
  end;
  // 
  FTemp.Seek(0,spBegin);
  for i:=1 to FullHeight do
  begin
    FTemp.Seek((FullHeight-i)*(FullWidth+Add),spBegin);
    Stream2Stream(SOut,FTemp,FullWidth+Add);
  end;
  SOut.Seek(0,spBegin);
  TempDef.Free;
  FTemp.Free;
end;

procedure TForm1.ListBox2Click(Sender: PObj);
begin
  if ListBox1.CurIndex<0 then Exit;
  if ListBox2.CurIndex<0 then Exit;
  FBmp:=NewMemoryStream;
  GetSprite(ListBox2.CurIndex,FBmp);
  FBmp.Seek(0,spBegin);
//  ShowMessage(Int2Str(FBmp.Size));
  TempBmp.LoadFromStream(FBmp);
  //
  AllowRepaint:=True;
  PaintBox1.Width:=TempBmp.Width;
  PaintBox1.Height:=TempBmp.Height;
  TempBmp.Draw(PaintBox1.Canvas.Handle,0,0);
  //
  FBmp.Free;
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
  if AllowRepaint then
  begin
    TempBmp.Draw(PaintBox1.Canvas.Handle,0,0);
//    PaintBox1.Width:=100;
  end else PaintBox1.Width:=0;
end;

procedure TForm1.KOLForm1N3Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

procedure TForm1.KOLForm1N2Menu(Sender: PMenu; Item: Integer);
begin
  Form2.Form.ShowModal;
  Form2.Form.Hide;
end;

procedure TForm1.PaintBox1Click(Sender: PObj);
begin
  if not OpenSaveDialog1.Execute then Exit;
  if Pos('.',OpenSaveDialog1.FileName)=0 then TempBmp.SaveToFile(OpenSaveDialog1.FileName+'.bmp') else TempBmp.SaveToFile(OpenSaveDialog1.FileName);
  CurDir:=ExtractFilePath(OpenSaveDialog1.FileName);
end;

procedure TForm1.Button3Click(Sender: PObj);
var
  i: LongInt;
begin
  if ListBox2.Count=0 then Exit;
  if OpenDirDialog2.Execute then
  begin
    Form3.Label1.Caption:=' ...';
    Form3.Form.Visible:=True;
    Form3.Form.Update;
    OpenDirDialog2.InitialPath:=OpenDirDialog2.Path;
    for i:=0 to ListBox2.Count-1 do
    if ListBox2.ItemSelected[i] then
    begin
      FBmp:=NewWriteFileStream(OpenDirDialog2.InitialPath+'\'+Copy(ListBox2.Items[i],1,Pos('.',ListBox2.Items[i]))+'bmp');
      GetSprite(i,FBmp);
      FBmp.Free;
    end;
    Form3.Form.Visible:=False;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: PObj);
begin
  Button1.Click;
end;

end.





















